﻿@{ ViewData["Title"] = "Home";
@model media_model.Media.MediaResponse
}

<h3 class="m-3 text-dark">Media</h3>
<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
    <div class="card card-primary card-outline">
        <div class="card-header">
            <div class="row">
                <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 mb-3">
                    @Html.LabelFor(m => m.search.FileName, new { @class = "col-xs-6 col-sm-4 col-md-4 col-lg-4 control-label f-left lh" })
                    <div class="col-xs-6 col-sm-8 col-md-8 col-lg-8 f-left">
                        @Html.TextBoxFor(m => m.search.FileName, new { @class = "form-control" })
                    </div>
                </div>
                <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 mb-3">
                    @Html.LabelFor(m => m.search.FileType, new { @class = "col-xs-6 col-sm-4 col-md-4 col-lg-4 control-label f-left lh" })
                    <div class="col-xs-6 col-sm-8 col-md-8 col-lg-8 f-left">
                        @Html.DropDownListFor(m => m.search.FileType, new SelectList(Model.search.mediaTypes, "Code", "Name", ""), new { @class = "form-control" })
                    </div>
                </div>
                <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 mb-3">
                    @Html.LabelFor(m => m.search.Month, new { @class = "col-xs-6 col-sm-4 col-md-4 col-lg-4 control-label f-left lh" })
                    <div class="col-xs-6 col-sm-8 col-md-8 col-lg-8 f-left">
                        @Html.DropDownListFor(m => m.search.Month, new SelectList(Model.search.months, "Code", "Name", ""), new { @class = "form-control" })
                    </div>
                </div>
                <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 mb-3">
                    @Html.LabelFor(m => m.search.Year, new { @class = "col-xs-6 col-sm-4 col-md-4 col-lg-4 control-label f-left lh" })
                    <div class="col-xs-6 col-sm-8 col-md-8 col-lg-8 f-left">
                        @Html.DropDownListFor(m => m.search.Year, new SelectList(Model.search.years, "Code", "Name", ""), new { @class = "form-control" })
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 mb-3 btn-s">
                    <button id="btnSearch" type="button" class="btn btn-primary pull-right col-lg-3 col-md-4 col-sm-4 col-xs-12" onclick="load();">Search</button>
                </div>
                <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 mb-3 btn-s">
                    <button type="button" class="btn btn-default col-lg-3 col-md-4 col-sm-4 col-xs-12" onclick="clearSearch();">Clear</button>
                </div>
            </div>
        </div>

        <div class="card-body">
            <p class="btn-s">
                <button type="submit" class="btn btn-success col-lg-2 col-md-3 col-sm-3 col-xs-12" onclick="gotoCreate()">
                    Create New
                </button>
            </p>
            <table id="dtResult" class="table">
                <thead>
                    <tr>
                        <th>
                            @Html.DisplayNameFor(m => m.data.Id)
                        </th>
                        <th>
                            No.
                        </th>
                        <th>
                            Action
                        </th>
                        <th>
                            @Html.DisplayNameFor(m => m.data.ThumbnailUrl)
                        </th>
                        <th>
                            @Html.DisplayNameFor(m => m.data.FileName)
                        </th>
                        <th>
                            @Html.DisplayNameFor(m => m.data.FileType)
                        </th>
                        <th>
                            @Html.DisplayNameFor(m => m.data.FileSize)
                        </th>
                        <th>
                            @Html.DisplayNameFor(m => m.data.CreatedBy)
                        </th>
                        <th>
                            @Html.DisplayNameFor(m => m.data.CreatedOnDisplay)
                        </th>
                    </tr>
                </thead>
                <tbody>
                </tbody>
            </table>
        </div>
    </div>
</div>

@section Scripts {
    <script>
        $(document).ready(function () {
            load();
        });

        function load() {
            var json = {
                "FileName": getValue("search_FileName"),
                "FileType": getValue("search_FileType"),
                "Month": getValue("search_Month"),
                "Year": getValue("search_Year")
            };

            $('#dtResult').DataTable().destroy();
            $('#dtResult').DataTable({
                "proccessing": true,
                "serverSide": true,
                "ajax": {
                    url: "/home/search",
                    type: 'POST',
                    data: json
                },
                "columnDefs": [
                    { "name": "Id", "data": "id", "targets": 0, "visible": false },
                    {
                        "targets": 1,
                        "data": null,
                        "className": 'dt-body-center',
                        "render": function (data, type, row, meta) {
                            return meta.row + meta.settings._iDisplayStart + 1;
                        },
                        "sortable": false
                    },
                    {
                        "targets": 2,
                        "data": null,
                        "render": function (data, type, row, meta) {
                            return renderBtn(row);
                        },
                        "sortable": false
                    },
                    {
                        "targets": 3,
                        "data": null,
                        "render": function (data, type, row, meta) {
                            return '<image src="' + data.thumbnailUrl + '" with="60" height="60" class="center">';
                        },
                        "sortable": false
                    },
                    { "name": "FileName", "data": "fileName", "targets": 4 },
                    { "name": "FileType", "data": "fileType", "targets": 5 },
                    { "name": "FileSize", "data": "fileSize", "targets": 6 },
                    { "name": "CreatedBy", "data": "createdBy", "targets": 7 },
                    { "name": "CreatedOnDisplay", "data": "createdOnDisplay", "targets": 8, "sortable": false }
                ],
                "order": [[0, "desc"]]
            });
        }

        function renderBtn(row) {
            var btnEdit = `<button type="button" class="btn btn-default btn-sm" onclick="gotoEdit(` + row.id + `)">
                  <i class='fas fa-edit' style='font-size:18px'></i></button> `;

            var btnDelete = `<button type="button" class="btn btn-default btn-sm" onclick="gotoDelete(` + row.id + `)">
                  <i class='fas fa-trash' style='font-size:18px'></i></button>`;
            return btnEdit + btnDelete;
        }

        function gotoCreate() {
            window.location.href = "/home/create";
        }

        function gotoEdit(id) {
            window.location.href = "/home/edit/" + id;
        }

        function gotoDelete(id) {
            var result = confirm("Do you want to delete?");
            if (result) {
                Loading(true);
                $.ajax({
                    url: "@Url.Content("~/media/delete")",
                    type: "POST",
                    data: { Id: id },
                    success: function (result) {
                        Loading(false);
                        alert("Delete successful");
                        load();
                    },
                    error: function (jqXHR) {
                        //
                    }
                });
            }
        }

        function clearSearch() {
            setValue("search_FileName", "");
            setValue("search_FileType", "");
            setValue("search_Month", "");
            setValue("search_Year", "");
            load();
        }

    </script>
}
